var textbox = 0;
var linespacing = "13";
var is = 0;  // information service

function onLoad() {

  if (!toi) {
    alert("TOI/JS 2 is not available, please check your whitelisturls.xml");
    alert(" and that your bootimage supports TOI/JS 2.");
    return;
  }

  try {
    is = toi.informationService;

    // set up a listener (see Information Service example for more info)
    is.addEventListener(is.ON_OBJECTS_CHANGED, OnEvent);
    is.subscribeObject(OnEvent, "cfg.media.channeltable", true);
  }
  catch (e) {
    alert(e);
  }

  textbox = document.getElementById("textbox");
}


function OnEvent() {
  if (!is.isObjectDefined("cfg.media.channeltable")) {
    alert("cfg.media.channeltable not found!");
    return;
  }

  // if there already is a channel table in the document, remove it
  if (textbox.childNodes.length > 0) {
    removeChannelTable();
  }

  // Next, the channel table is split into strings.
  // For each string, a new DOM tspan element is created and
  // appended to the document. This is because svg does not
  // handle newlines or perform wordwrapping
  var channeltable = is.getObject("cfg.media.channeltable");
  var channelarray = channeltable.split("\n");

  for (i=0; i<channelarray.length; i++) {
    var e = document.createElement("tspan");
    e.textContent = channelarray[i];
    e.setAttribute("x", "0");
    e.setAttribute("dy", linespacing);
    textbox.appendChild(e);
  }

}

function onUnload() {
  is.removeEventListener(is.ON_OBJECTS_CHANGED, OnEvent);
}


function removeChannelTable() {
  // keep deleting the elements until there are none left
  while (textbox.childNodes.length>0) {
    textbox.removeChild(textbox.firstChild);
  }
}


