var linklist = 0;
var links = new Array();
var currentItem = 0; // position of selection...
var linespacing = 16;

function onLoad() {
  document.addEventListener("keydown", onKeyDown, false);

  linklist = document.getElementById("linklist");
  while (linklist.childNodes.length>0) {
    linklist.removeChild(linklist.firstChild);
  }

  var obj = new example();
  obj.Name = "Hello World";
  obj.URI = "helloworld/helloworld.svg";
  obj.Description = [
    'The Hello World example shows how to create a simple svg page which',
    'displays some text on the TV screen'];
  addObject(obj);

  obj = new example();
  obj.Name = "Keycodes";
  obj.URI = "keycodes/keycodes.svg";
  obj.Description = [
      'Key presses on a remote control or keyboard are received by the portal',
      'as keyIdentifier events which correspond as much as possible to the ',
      'key and keyboard events defined by the W3C.',
      'The Standby button is treated differently, and its use is shown in',
      'the Information Service example.' ];
  addObject(obj);

  obj = new example();
  obj.Name = "Information Service";
  obj.URI = "informationservice/informationservice.svg";
  obj.Description = [
    'The KreaTV platform is composed of several services useful to portal',
    'developers. The Information Service is a database of configuration',
    'objects. Each object has a name and a string value. Objects can be',
    'created, set, saved to flash memory and broadcast and received from',
     ' an Infocast Server. The Information Service provides callbacks so the',
     'portal can react to changes in these objects.'];
  addObject(obj);

  obj = new example();
  obj.Name = "Channel Table";
  obj.URI = "channeltable/channeltable.svg";
  obj.Description = [
    'This example subscribes to the cfg.media.channeltable object which',
    'is broadcast from an Infocast Server. This holds a list of TV',
    'channel names, and their multicast IP address. The example uses',
    'a listener to be informed of changes to the object, for instance when',
    'a channel is added or removed from the list. When this',
    'occurs, the list shown on the TV screen is updated.'];
  addObject(obj);

  obj = new example();
  obj.Name = "Front LED demo";
  obj.URI = "frontled/frontled.svg";
  obj.Description = [
    'The Front Panel Service allows access to the LEDs on the front panel',
    'of the STB. This example shows how these LEDs are selected and',
    'turned on/off and how colour values may be used.',
    'Please note that different models of IP-STB have different LED',
    'capabilities.'];
  addObject(obj);

  obj = new example();
  obj.Name = "TV Portal";
  obj.URI = "tvportal/tvportal";
  obj.Description = [
    'This example shows how a very simple TV portal can be created. It',
    'uses the platforms Media Service to open a URI (a multicast IP',
    'address) and begins to play the data. A special SVG tag,',
    '"video", is used to manage the display.'];
  addObject(obj);

  obj = new example();
  obj.Name = "Audio Tracks";
  obj.URI = "audiotracks/audiotracks.svg";
  obj.Description = [
    'This example queries the Media Service for information about the',
    'currently playing stream. It determines which audio tracks are',
    'available and displays information about each one, such as the',
    'format, language and sample rate.'];
  addObject(obj);

  obj = new example();
  obj.Name = "Display Info";
  obj.URI = "displayinfo/displayinfo.svg";
  obj.Description = [
      'The video output service provides access to several video outputs.',
      'These outputs can return information about the attached',
      'display. This example shows how to retrieve this information for',
      'available video outputs.'];
  addObject(obj);

  obj = new example();
  obj.Name = "Video Output";
  obj.URI = "videooutput/videooutput.svg";
  obj.Description = [
      'The video output service allows you to set the output resolution',
      'for the different output devices using a transaction based system.'];
  addObject(obj);

  obj = new example();
  obj.Name = "Timeshift";
  obj.URI = "timeshift/timeshift.svg";
  obj.Description = [
    'This example uses the Media Player\'s Timeshift functionality to',
    'allow the user to pause the TV. It is possible to rewind and ',
    'fastforward through the timeshift buffer, and finally return to the',
    'live TV broadcast again.',
    'The Media Player states and events are shown onscreen to aid',
    'in understanding how the timeshift API works.' ];
  addObject(obj);

  selectItem(currentItem);
}


function addObject(obj) {
  var e = document.createElement("text");
  e.textContent = obj.Name;
  linklist.appendChild(e);
  e.setAttribute("dy", links.length*linespacing);

  links.push(obj);
}

function showObjInInfobox(item) {
  var obj = links[item];

  var infobox = document.getElementById("informationbox");

  // remove old info
  while (infobox.childNodes.length>0) {
    infobox.removeChild(infobox.firstChild);
  }

  // add object info
  for (var i=0; i<obj.Description.length; i++) {
    var t = document.createElement("tspan");
    t.setAttribute("dy",linespacing.toString());
    t.setAttribute("x","10");
    t.textContent = obj.Description[i];
    infobox.appendChild(t);
  }

  t = document.createElement("tspan");
  t.setAttribute("dy", (linespacing*2).toString());
  t.setAttribute("x", "10");
  t.textContent = "Press OK to see this example in action.";
  infobox.appendChild(t);
}

function example() {
  this.Name = "Example Name";
  this.URI = "test/test.svg";
  this.Description = ['Hello','world','description','goes','here'];
}

function selectItem(item) {
  linklist.childNodes[item].setAttribute("fill", "#ff0000");
  showObjInInfobox(item);
}

function unselectItem(item) {
  linklist.childNodes[item].setAttribute("fill", "#000000");
}


function onKeyDown(keyevent) {
  var key = keyevent.keyIdentifier;

  switch (key) {
    case "Up":
      unselectItem(currentItem);
      if (currentItem==0) {
        currentItem = links.length-1;
      }
      else {
        currentItem--;
      }
      selectItem(currentItem);
      break;
    case "Down":
      unselectItem(currentItem);
      if (currentItem==links.length-1) {
        currentItem = 0;
      }
      else {
        currentItem++;
      }
      selectItem(currentItem);
      break;
    case "Accept":
      location.href=links[currentItem].URI;
      break;
  }
}


function onUnload() {
  document.removeEventListener("keydown", onKeyDown, false);
}

