var is = null;

function onLoad() {
  try {
    is = toi.informationService;

    // set up listener, and subscibe to interesting objects
    is.addEventListener(is.ON_OBJECTS_CHANGED, onEvent);
    is.subscribeObject(onEvent, "cfg.media.subtitling.autoselection", true);
    is.subscribeObject(onEvent, "var.ip.eth0.addr", true);
    is.subscribeObject(onEvent, "var.io.state", true);
    is.subscribeObject(onEvent, "cfg.custom.object", true);
  }
  catch (e) {
    alert(e);
  }
}


function onUnload() {
  is.removeEventListener(is.ON_OBJECTS_CHANGED, onEvent);
}


function onEvent(event) {
  /* Events are different depending on what service is generating them.
   * See ToiInformationObjectsChangedEvent in manual for description of
   * * this event object */
  var numObjs = event.objectNames.length;
  for (i=0; i<numObjs; i++) {
    alert(event.objectNames[i] + " has changed to " +
            is.getObject(event.objectNames[i]));

    setElementToObject(event.objectNames[i]);
  }
}


function setElementToObject(objectName) {
  if (!is) {
    alert("Information Service not initialized!");
    return;
  }

  var element = 0;
  var configObjectValue = 0;

  alert("objname is " + objectName);
  if ( !is.isObjectDefined(objectName) ) {
      alert("undefined!!!");
    configObjectValue = "Undefined";
  }
  else {
    configObjectValue = is.getObject(objectName);
  }
  // the object names use a '.' character, but the DOM element ID used for
  // display uses an '_' instead, so we need to do a replace...
  var elementId = objectName.replace(/\./g, '_');

  element = document.getElementById(elementId);
  if (!element) {
    alert("Cannot find element " + elementId);
    return;
  }

  element.textContent = configObjectValue;

  // set font to red for one second.. just indicating that it's changed
  element.setAttribute("fill", "#ff0000");
  setTimeout("restoreColor('" + elementId + "');", 1000);
}



function restoreColor(elementId) {
  var element = document.getElementById(elementId);
  element.setAttribute("fill", "#000000");
}


