
// display elements in DOM
var e_keyIdentifier = 0;
var e_keyLocation = 0;
var e_ctrlKey = 0;
var e_shiftKey = 0;
var e_altKey = 0;
var e_metaKey = 0;

var e_colorbox = 0;

// Handy definitions for common keycodes
var KEY_0     = "U+0030";
var KEY_1     = "U+0031";
var KEY_2     = "U+0032";
var KEY_3     = "U+0033";
var KEY_4     = "U+0034";
var KEY_5     = "U+0035";
var KEY_6     = "U+0036";
var KEY_7     = "U+0037";
var KEY_8     = "U+0038";
var KEY_9     = "U+0039";

var KEY_STOP  = "Stop";
var KEY_OK    = "Accept";
var KEY_MUTE  = "VolumeMute";

var KEY_SCROLL_UP     = "ScrollUp";
var KEY_SCROLL_DOWN   = "ScrollDown";
var KEY_SCROLL_LEFT   = "ScrollLeft";
var KEY_SCROLL_RIGHT  = "ScrollRight";

var KEY_RED   = "Red";
var KEY_GREEN   = "Green";
var KEY_YELLOW  = "Yellow";
var KEY_BLUE  = "Blue";

function onLoad() {
  document.addEventListener("keydown", handleRawKeyEvent, false);

  // find the elements used to display values
  // this search is performed once, at startup, and the results saved.
  // this removes the need for getElementById() calls during the running of
  // the portal, making it faster.
  e_keyIdentifier   = document.getElementById("keyIdentifier");
  e_keyLocation   = document.getElementById("keyLocation");
  e_ctrlKey     = document.getElementById("ctrlKey");
  e_shiftKey    = document.getElementById("shiftKey");
  e_altKey      = document.getElementById("altKey");
  e_metaKey     = document.getElementById("metaKey");

  e_colorbox = document.getElementById("colorbox");
  e_colorbox.setAttribute("fill", "#c0d0c0");
}


function handleRawKeyEvent(ev) {
  var key = ev.keyIdentifier;

  // show the raw event on screen and in log
  showEvent(ev);

  // if ctrl is true, change the type of direction key...
  // Consider this a kind of pre-processing step to handle the modifier keys..
  if (ev.ctrlKey) {
    switch (key) {
    case "Up":
      key = KEY_SCROLL_UP;
      break;
    case "Down":
      key = KEY_SCROLL_DOWN;
      break;
    case "Left":
      key = KEY_SCROLL_LEFT;
      break;
    case "Right":
      key = KEY_SCROLL_RIGHT;
      break;
    }
  }

  // send the key identifier further
  onKeyDown(key);
}



function onKeyDown(key) {
  // if it was a color, change the box to that color. else make it clear again
  switch (key) {
    case "Red":
    e_colorbox.setAttribute("fill", "#ff0000");
    break;
    case "Green":
    e_colorbox.setAttribute("fill", "#00ff00");
    break;
    case "Blue":
    e_colorbox.setAttribute("fill", "#0000ff");
    break;
    case "Yellow":
    e_colorbox.setAttribute("fill", "#ffff00");
    break;

    default:
    e_colorbox.setAttribute("fill", "#c0d0c0");
  }

  // if it was a scroll key, move the box
  switch (key) {
    case "ScrollUp":
    e_colorbox.setAttribute("y", e_colorbox.getAttribute("y") - 5);
    alert("y is " + e_colorbox.getAttribute("y"));
    break;
    case "ScrollDown":
    e_colorbox.setAttribute("y", parseInt(e_colorbox.getAttribute("y")) + 5);
    alert("y is " + e_colorbox.getAttribute("y"));
    break;
    case "ScrollLeft":
    e_colorbox.setAttribute("x", e_colorbox.getAttribute("x") - 5);
    alert("x is " + e_colorbox.getAttribute("x"));
    break;
    case "ScrollRight":
    e_colorbox.setAttribute("x", parseInt(e_colorbox.getAttribute("x")) + 5);
    alert("x is " + e_colorbox.getAttribute("x"));
    break;
  }
}

function showEvent(ev) {
  // show in log
  alert("keyIdentifier is " + ev.keyIdentifier);
  alert("keyLocation is " + ev.keyLocation);
  alert("ctrlKey is " + ev.ctrlKey);
  alert("shiftKey is " + ev.shiftKey);
  alert("altKey is " + ev.altKey);
  alert("metaKey is " + ev.metaKey + "\n");

  // display received values on TV screen
  e_keyIdentifier.textContent = ev.keyIdentifier;
  e_keyLocation.textContent = ev.keyLocation;
  e_ctrlKey.textContent = ev.ctrlKey;
  e_shiftKey.textContent = ev.shiftKey;
  e_altKey.textContent = ev.altKey;
  e_metaKey.textContent = ev.metaKey;
}


function onUnload()
{
  document.removeEventListener("keydown", onKeyDown, false);
}

