var mediaPlayer = null;

var channels = [
        "224.5.5.1:11111",
        "224.5.5.1:11111",
        "224.5.80.1:10000",
        "224.5.5.2:11111",
        "224.5.80.5:10000"
        ];

var nrChannels = channels.length;
var currChan = 0;


function onLoad() {
  document.addEventListener("keydown", onKeyDown, false);
  createPlayer();

  var video = document.getElementById("videoplane");
  // see svg browser extensions document for more details (included with PDG)
  video.setAttributeNS("http://www.ekioh.com/2007/ekioh",
                        "colourKey", "#ff0000");

  play(channels[currChan]);
}


function incChan() {
  currChan = currChan + 1;
  if (currChan == nrChannels) {
    currChan = 0;
  }
}

function decChan() {
  currChan = currChan - 1;
  if (currChan == -1) {
    currChan = nrChannels - 1;
  }
}

function createPlayer() {
  try {
    mediaPlayer = toi.mediaService.createPlayerInstance();
  }
  catch (e) {
    alert("Failed creating player: " + e);
  }
}

function play(uri) {
  try {
    if (null == mediaPlayer)  {
      alert("play, no mediaplayer");
    }

    if (mediaPlayer.getState() != mediaPlayer.STATE_IDLE) {
      mediaPlayer.close();
    }

    document.getElementById("videourl").textContent = uri;
    mediaPlayer.open(uri);
    mediaPlayer.play(mediaPlayer.PACE_PLAY);
  }
  catch (e) {
    alert("Failed opening stream: " + e);
    return;
  }
}
function onKeyDown(ev) {
  var key = ev.keyIdentifier;
  alert("key is " + key);

  switch (key) {
  case "Accept":
    if (mediaPlayer.getState() == mediaPlayer.STATE_IDLE) {
      play(channels[currChan]);
    }
    else if (mediaPlayer.getState() == mediaPlayer.STATE_PAUSED) {
      mediaPlayer.play(mediaPlayer.PACE_PLAY);
    }
    else {
      mediaPlayer.play(mediaPlayer.PACE_PAUSE);
    }
    break;
  case "Stop":
    mediaPlayer.close();
    break;
  case "Rewind":
    mediaPlayer.play(mediaPlayer.PACE_REWIND);
    break;
  case "Forward":
    mediaPlayer.play(mediaPlayer.PACE_FASTFORWARD);
    break;
  case "Up":
    incChan();
    play(channels[currChan]);
    break;
  case "Down":
    decChan();
    play(channels[currChan]);
    break;
  case "Red":
    alert(mediaPlayer.getState());
    break;
  default:
    break;
  }
}


function onUnload()
{
  alert("onunload");
  try {
    if (mediaPlayer.getState() != mediaPlayer.STATE_IDLE) {
      mediaPlayer.close();
      alert("Has closed.");
    }
    mediaPlayer.releaseInstance();
    mediaPlayer = null;

    document.removeEventListener("keydown", onKeyDown, false);
  }
  catch (e) {
    alert("onUnload error:" + e);
  }
}

